function Opl00200_TipoOperacaoOperadorLogistico_Controller(ScreenService, templateManager, ZhFilterPreferences, General) {
	
	var var_CDFILIOPELOG;
	var var_NMFILIALOL;
    
    this.openFilter = function(widget) {
        ScreenService.showLoader();
        this.setFieldsGerais(widget);
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.TNMFILIAL = 'T';
		delete widget.getField("NMFILIALL").validations.required;
		delete widget.getField("NMFILIALL").filterProperties.validations.required;
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			ScreenService.hideLoader();
		}).catch(error => {
			console.log(error);
			ScreenService.hideLoader();
		});
    };
    
	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
	
	this.changeFieldListaUnidades = function(args) {
		var widget = args.owner.field.widget;
		var row = args.row;
		ScreenService.showLoader();
		if(!row.CDFILIOPELOG) {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TNMFILIAL").readOnly = true;
					widget.getField("TNMFILIAL").readOnlyOnEdit = true;
					widget.currentRow.TNMFILIAL = "T";
					widget.currentRow.CDFILIAL = "";
					widget.getField("NMFILIALL").clearValue();
					delete widget.getField("NMFILIALL").validations.required;
					delete widget.getField("NMFILIALL").filterProperties.validations.required;
					widget.getField("NMFILIALL").reload();
					widget.getField("TNMFILIAL").reload();
					this.changeFieldUnidade(args);
					ScreenService.hideLoader();
				}, 200);
			} else if(widget.name === "widgetTipoOperacao") {
				widget.getField("NMFILIAL").clearValue();
				widget.getField("NMFILIAL").readOnly = true;
				widget.getField("NMFILIAL").readOnlyOnEdit = true;
				widget.getField("NMFILIAL").dataSourceFilter = [
					{
						"name": "P_CDFILIAL",
                    	"operator": "=",
                    	"value": args.row.CDFILIOPELOG
					},
					{
						"name": "P_CDOPERADOR",
						"operator": "=",
						"value": getLocalVar("CDOPERADOR")
					
					}
				];
				widget.getField("NMFILIAL").reload();
				ScreenService.hideLoader();
			} else {
				ScreenService.hideLoader();
			}
		} else if(row.CDFILIOPELOG) {
			var_CDFILIOPELOG = row.CDFILIOPELOG;
			var_NMFILIALOL = row.NMFILIALOL;
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TNMFILIAL").readOnly = false;
					widget.getField("TNMFILIAL").readOnlyOnEdit = false;
					widget.getField("NMFILIALL").clearValue();
					widget.getField("NMFILIALL").reload();
					widget.getField("TNMFILIAL").reload();
					this.changeFieldUnidade(args);
					ScreenService.hideLoader();
				}, 200);
			} else if(widget.name === "widgetTipoOperacao") {
				widget.getField("NMFILIAL").clearValue();
				widget.getField("NMFILIAL").readOnly = false;
				widget.getField("NMFILIAL").readOnlyOnEdit = false;
				widget.getField("NMFILIAL").dataSourceFilter = [
					{
						"name": "P_CDFILIAL",
                    	"operator": "=",
                    	"value": args.row.CDFILIOPELOG
					},
					{
						"name": "P_CDOPERADOR",
						"operator": "=",
						"value": getLocalVar("CDOPERADOR")
					
					}
				];
				widget.getField("NMFILIAL").reload();
				ScreenService.hideLoader();
			} else {
				ScreenService.hideLoader();
			}
		}
	};
	
	this.changeFieldUnidade = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TNMFILIAL == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIALL").readOnly = true;
					widget.getField("NMFILIALL").readOnlyOnEdit = true;
					delete widget.getField("NMFILIALL").validations.required;
					widget.currentRow.NMFILIALL = "";
					widget.currentRow.CDFILIAL = "";
					widget.getField("NMFILIALL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TNMFILIAL == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIALL").readOnly = false;
					widget.getField("NMFILIALL").readOnlyOnEdit = false;
					widget.getField("NMFILIALL").validations.required = true;
					widget.getField("NMFILIALL").dataSourceFilter = [
						{
							"name": "P_CDFILIAL",
                            "operator": "=",
                            "value": args.row.CDFILIOPELOG
						},
						{
							"name": "P_CDOPERADOR",
							"operator": "=",
							"value": getLocalVar("CDOPERADOR")
						}
					];
					widget.getField("NMFILIALL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(widget.name === "widgetTipoOperacao") {
			widget.getField("NMFILIAL").dataSourceFilter = [
				{
					"name": "P_CDFILIAL",
                    "operator": "=",
                    "value": args.row.CDFILIOPELOG
				},
				{
					"name": "P_CDOPERADOR",
					"operator": "=",
					"value": getLocalVar("CDOPERADOR")
					
				}
			];
			widget.getField("NMFILIALL").reload();
			ScreenService.hideLoader();
		} else {
			args.row.TNMFILIAL = "T";
			widget.currentRow.TNMFILIAL = "T";
			ScreenService.hideLoader();
		}
	};
	
	this.newType = function(widget) {
		widget.newRow();
		widget.getField("NMFILIALOL").readOnly = true;
		widget.currentRow.NMFILIALOL = var_NMFILIALOL;
		widget.currentRow.CDFILIOPELOG = var_CDFILIOPELOG;
		widget.getField("NMFILIALOL").reload();
		widget.getField("NMFILIAL").readOnly = false;
		widget.getField("NMFILIAL").dataSourceFilter = [
				{
					"name": "P_CDFILIAL",
                    "operator": "=",
                    "value": var_CDFILIOPELOG
				},
				{
					"name": "P_CDOPERADOR",
					"operator": "=",
					"value": getLocalVar("CDOPERADOR")
					
				}
			];
		widget.getField("NMFILIAL").reload();
		widget.getField("IDTIPOOPERENTR").setValue("E");
		widget.getField("IDTIPOOPERENTR").reload();
		widget.getField("IDTIPOOPERSAID").setValue("S");
		widget.getField("IDTIPOOPERSAID").reload();
	};
	
	this.editType = function(widget) {
		widget.edit();
		widget.getField("NMFILIALOL").readOnly = true;
		widget.currentRow.NMFILIALOL = var_NMFILIALOL;
		widget.currentRow.CDFILIOPELOG = var_CDFILIOPELOG;
		widget.currentRow.CDFILDEST = widget.currentRow.CDFILIAL;
		widget.getField("NMFILIALOL").reload();
		widget.getField("NMFILIAL").readOnlyOnEdit = true;
		widget.getField("NMFILIAL").reload();
		widget.getField("CDFILDEST").setValue(widget.currentRow.CDFILIAL);
		widget.getField("CDFILDEST").reload();
		widget.getField("CDSERIE").readOnly = false;
		widget.getField("CDSERIE").readOnlyOnEdit = false;
		widget.getField("CDSERIE").dataSourceFilter = [
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": widget.currentRow.CDFILIAL
			}
		];
		widget.getField("CDSERIE").reload();
		widget.getField("IDTIPOOPERENTR").setValue("E");
		widget.getField("IDTIPOOPERENTR").reload();
		widget.getField("IDTIPOOPERSAID").setValue("S");
		widget.getField("IDTIPOOPERSAID").reload();
	};
	
	this.deleteType = function(widget) {
		widget.currentRow.CDFILDEST = widget.currentRow.CDFILIAL;
		widget.currentRow.CDFILIOPELOG = var_CDFILIOPELOG;
		General.deleteCrud(widget);
	};
	
	this.changeFieldSerieNF = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.CDFILIAL) {
			widget.getField("CDFILDEST").setValue(args.row.CDFILIAL);
			args.row.CDFILDEST = args.row.CDFILIAL;
			widget.getField("CDSERIE").readOnly = false;
			widget.getField("CDSERIE").readOnlyOnEdit = false;
			widget.getField("CDSERIE").clearValue();
			widget.getField("CDSERIE").dataSourceFilter = [
				{
					"name": "P_CDFILIAL",
					"operator": "=",
					"value": args.row.CDFILIAL
				}
			];
			widget.getField("CDSERIE").reload();
			widget.getField("CDFILDEST").reload();
			ScreenService.hideLoader();
		} else {
			widget.getField("CDSERIE").readOnly = true;
			widget.getField("CDSERIE").clearValue();
			widget.getField("CDSERIE").reload();
			ScreenService.hideLoader();
		}
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register("Opl00200_TipoOperacaoOperadorLogistico_Controller", Opl00200_TipoOperacaoOperadorLogistico_Controller);
});